# Bulk Create Documents POST /api/v1/content-vault/documents/bulk-create/ Content-Type: multipart/form-data Create multiple documents in a single request. Supports: - Multiple file uploads with automatic naming - CSV string of URLs for bulk URL document creation - JSON list of URLs for structured bulk creation All created documents share common configuration and type. Reference: https://docs.aisquare.studio/api-reference/ai-square-studio-api/content-vault/documents-bulk-create-create ## OpenAPI Specification ```yaml openapi: 3.1.0 info: title: AISquare Studio API version: 1.0.0 paths: /api/v1/content-vault/documents/bulk-create/: post: operationId: documents-bulk-create-create summary: Bulk Create Documents description: |- Create multiple documents in a single request. Supports: - Multiple file uploads with automatic naming - CSV string of URLs for bulk URL document creation - JSON list of URLs for structured bulk creation All created documents share common configuration and type. tags: - subpackage_contentVault responses: '201': description: Documents created successfully content: application/json: schema: $ref: '#/components/schemas/PaginatedRAGDocumentListList' '400': description: Validation error content: application/json: schema: description: Any type '401': description: Authentication required content: application/json: schema: description: Any type requestBody: content: multipart/form-data: schema: type: object properties: document_files: type: array items: type: string format: uri description: List of files to upload urls_csv: type: string description: Comma-separated URLs to create documents from urls_list: type: array items: type: string format: uri description: List of URLs to create documents from document_type: $ref: '#/components/schemas/RAGDocumentTypeEnum' description: |- Document type for all created documents * `file` - File * `url` - URL * `user` - User * `text` - Text * `youtube` - YouTube * `gdrive` - Google Drive * `email` - Email * `rss` - RSS Feed config: description: Common configuration applied to all documents auto_name: type: boolean default: true description: Automatically generate names from filenames/URLs name_prefix: type: string description: Optional prefix for all document names required: - document_type components: schemas: RAGDocumentTypeEnum: type: string enum: - file - url - user - text - youtube - gdrive - email - rss description: |- * `file` - File * `url` - URL * `user` - User * `text` - Text * `youtube` - YouTube * `gdrive` - Google Drive * `email` - Email * `rss` - RSS Feed title: RAGDocumentTypeEnum UploadStatusEnum: type: string enum: - importing - vectorizing - summarizing - uploaded - failed description: |- * `importing` - Importing * `vectorizing` - Vectorizing * `summarizing` - Summarizing * `uploaded` - Uploaded * `failed` - Failed title: UploadStatusEnum SimpleUser: type: object properties: id: type: integer email: type: string format: email full_name: type: string username: type: string description: >- Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only. is_verified: type: boolean profile_picture: type: string format: uri description: |- Convert ImageFieldFile to URL string for JSON serialization. Args: obj: The model instance being serialized (typically IAMUser) Returns: str | None: The URL of the profile picture, or None if not available required: - id - email - full_name - username - is_verified - profile_picture description: >- Simple user serializer with profile picture from associated IAMUserDetail. Fields: - id, email, full_name, username, is_verified (from IAMUser) - profile_picture (from first related IAMUserDetail if present) title: SimpleUser RAGDocumentList: type: object properties: document_id: type: integer document_name: type: - string - 'null' document_type: $ref: '#/components/schemas/RAGDocumentTypeEnum' document_url: type: - string - 'null' content: type: - string - 'null' created_at: type: string format: date-time updated_at: type: string format: date-time config: oneOf: - description: Any type - type: 'null' file_type: type: - string - 'null' file_size: type: - integer - 'null' upload_status: $ref: '#/components/schemas/UploadStatusEnum' status_message: type: - string - 'null' description: Human-readable status / failure message for ingestion linked_experiences_count: type: integer linked_experiences: type: array items: type: object additionalProperties: description: Any type has_file: type: boolean description: type: string workspace: type: string workspace_id: type: integer owner: $ref: '#/components/schemas/SimpleUser' description: Owner/uploader user object progress: type: integer description: Processing progress as percentage (0-100) required: - document_id - created_at - updated_at - file_type - file_size - upload_status - status_message - linked_experiences_count - linked_experiences - has_file - description - workspace - workspace_id - owner - progress description: Serializer for listing RAG documents with file metadata title: RAGDocumentList PaginatedRAGDocumentListList: type: object properties: count: type: integer next: type: - string - 'null' format: uri previous: type: - string - 'null' format: uri results: type: array items: $ref: '#/components/schemas/RAGDocumentList' required: - count - results title: PaginatedRAGDocumentListList ``` ## SDK Code Examples ```python import requests url = "https://api.example.com/api/v1/content-vault/documents/bulk-create/" payload = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"document_files\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"urls_csv\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"urls_list\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"document_type\"\r\n\r\nfile\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"config\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"auto_name\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"name_prefix\"\r\n\r\n\r\n-----011000010111000001101001--\r\n" headers = {"Content-Type": "multipart/form-data; boundary=---011000010111000001101001"} response = requests.post(url, data=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.example.com/api/v1/content-vault/documents/bulk-create/'; const form = new FormData(); form.append('document_files', ''); form.append('urls_csv', ''); form.append('urls_list', ''); form.append('document_type', 'file'); form.append('config', ''); form.append('auto_name', ''); form.append('name_prefix', ''); const options = {method: 'POST'}; options.body = form; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.example.com/api/v1/content-vault/documents/bulk-create/" payload := strings.NewReader("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"document_files\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"urls_csv\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"urls_list\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"document_type\"\r\n\r\nfile\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"config\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"auto_name\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"name_prefix\"\r\n\r\n\r\n-----011000010111000001101001--\r\n") req, _ := http.NewRequest("POST", url, payload) res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.example.com/api/v1/content-vault/documents/bulk-create/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request.body = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"document_files\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"urls_csv\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"urls_list\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"document_type\"\r\n\r\nfile\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"config\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"auto_name\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"name_prefix\"\r\n\r\n\r\n-----011000010111000001101001--\r\n" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.example.com/api/v1/content-vault/documents/bulk-create/") .body("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"document_files\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"urls_csv\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"urls_list\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"document_type\"\r\n\r\nfile\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"config\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"auto_name\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"name_prefix\"\r\n\r\n\r\n-----011000010111000001101001--\r\n") .asString(); ``` ```php request('POST', 'https://api.example.com/api/v1/content-vault/documents/bulk-create/', [ 'multipart' => [ [ 'name' => 'document_type', 'contents' => 'file' ] ] ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.example.com/api/v1/content-vault/documents/bulk-create/"); var request = new RestRequest(Method.POST); request.AddParameter("undefined", "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"document_files\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"urls_csv\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"urls_list\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"document_type\"\r\n\r\nfile\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"config\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"auto_name\"\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"name_prefix\"\r\n\r\n\r\n-----011000010111000001101001--\r\n", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let parameters = [ [ "name": "document_files", "value": ], [ "name": "urls_csv", "value": ], [ "name": "urls_list", "value": ], [ "name": "document_type", "value": "file" ], [ "name": "config", "value": ], [ "name": "auto_name", "value": ], [ "name": "name_prefix", "value": ] ] let boundary = "---011000010111000001101001" var body = "" var error: NSError? = nil for param in parameters { let paramName = param["name"]! body += "--\(boundary)\r\n" body += "Content-Disposition:form-data; name=\"\(paramName)\"" if let filename = param["fileName"] { let contentType = param["content-type"]! let fileContent = String(contentsOfFile: filename, encoding: String.Encoding.utf8) if (error != nil) { print(error as Any) } body += "; filename=\"\(filename)\"\r\n" body += "Content-Type: \(contentType)\r\n\r\n" body += fileContent } else if let paramValue = param["value"] { body += "\r\n\r\n\(paramValue)" } } let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/api/v1/content-vault/documents/bulk-create/")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```